///////////////////////////////////////////////////////////////////////////////////
// material helper functions



material* mtl1;

function mtl_copy(mtl_source)
{
  mtl1 = mtl_source;
  vec_set(mtl.ambient_blue,mtl1.ambient_blue);
  vec_set(mtl.specular_blue,mtl1.specular_blue);
  vec_set(mtl.diffuse_blue,mtl1.diffuse_blue);
  vec_set(mtl.emissive_blue,mtl1.emissive_blue);
  mtl.power = mtl1.power;
}

// bmap bmp_envcube	= <Desert+6.bmp>;
bmap bmp_envcube	= <skycube2+6.bmp>;
bmap bmp_reflex		= <Raum+6.bmp>;
bmap bmp_traum		= <Traumraum+6.bmp>;
bmap bmp_balkon		= <Balkon+6.bmp>;
bmap bmp_bad		= <Bad+6.bmp>;
bmap bmp_pool       = <Pool2.bmp>;
bmap bmp_caustic    = <pool_caustic2.tga>;


// generate a matrix that transforms camera space back to world space
function mtl_env_view()
{
  mat_set(mtl.matrix,matViewInv);
// reset the translation part of the matrix
  mtl.matrix41 = 0;
  mtl.matrix42 = 0;
  mtl.matrix43 = 0;
}

function mtl_env_init()
{
  bmap_to_cubemap(mtl.skin4);
//  bmap_to_uv(bmap_for_entity(my,2));
  mtl.event = mtl_env_view;
  mtl.enable_view = on;
}


/*
material mtl_envcube // environment cube
{
  skin4 = bmp_envcube;
  event = mtl_env_init;

  effect = "
    texture mtlSkin4;
	texture entSkin2;
    matrix matMtl;

    technique envcube
    {
      pass p0
      {
		/////////////////////// Bump - Anfang
		
		BumpEnvMat00[0] = 0.5f;
		BumpEnvMat01[0] = 0.0f;
		BumpEnvMat10[0] = 0.0f;
		BumpEnvMat11[0] = 0.5f;

        Texture[0] = <entSkin2>;
        ColorArg1[0] = Texture;
        ColorArg2[0] = Diffuse;
		ColorOp[0] = BumpEnvMap;
	
		////////////////////// Bump - Ende

		TextureFactor = 0xFFFF0000;
		ColorArg1[0] = Tfactor;
		ColorOp[0] = SelectArg1;

        AddressU[1] = Clamp;  // don't wrap around edges
        AddressV[1] = Clamp;

        TexCoordIndex[1] = CameraSpaceReflectionVector;
        TextureTransformFlags[1] = Count3;
        TextureTransform[1] = <matMtl>; // transform camera space back to world space

        Texture[1] = <mtlSkin4>;
        ColorArg1[1] = Texture;
        ColorArg2[1] = Current;
		ColorOp[1] = Add;

      }
    }

    technique fallback { pass p0 { } } // empty fallback causes normal rendering without effect
  ";
}

*/


//////////////////////////////// Verbesserung

material mtl_envcube
{
        skin1=  bmp_envcube;
        event=  mtl_env_init;

        effect=
        "
                texture entSkin1;
                texture mtlSkin1;
                matrix matMtl;
                technique envmap
                {
                        pass p0
                        {
                                texture[0]=<entSkin1>;
                                texture[1]=<mtlSkin1>;

                                zWriteEnable=true;
                                alphaBlendEnable=false;

                                colorArg1[0]=Texture;
                                colorOp[0]=Modulate2x;
                                colorArg2[0]=Diffuse;

                                colorArg1[1]=Texture;
                                colorOp[1]=blendCurrentAlpha;
                                addressU[1]=Clamp;
                                addressV[1]=Clamp;
                                texCoordIndex[1]=cameraSpaceReflectionVector;
                                textureTransformFlags[1]=Count3;
                                textureTransform[1]=<matMtl>; // transform camera space back to world space
                        }
                }
        ";
}






action envcube {
	my.material = mtl_envcube;
	//while(1) { my.pan += time; wait(1); }
}





////////////////////////////////////////////////////////////////////////////////
material* Spiegelung;



function mtl_envmirror_view()
{
  mat_set(mtl.matrix,matViewInv);
// reset the translation part of the matrix
  mtl.matrix41 = 0;
  mtl.matrix42 = 0;
  mtl.matrix43 = 0;
// mirror the matrix in y direction (= screen plane normal),
  mat_scale(mtl.matrix,1,-1,1);
}


var skin_attribut = 0;

function mtl_skin_choice(no)
{
/*
if (skin_attribut == 0)
	{
	mtl.skin1 = bmp_reflex;
	}

if (skin_attribut == 1)
	{
	mtl.skin1 = bmp_traum;
	}

if (skin_attribut == 2)
	{
	mtl.skin1 = bmp_balkon;
	}
*/
if (no == 0)
	{
	mtl.skin1 = bmp_reflex;
	}

if (no == 1)
	{
	mtl.skin1 = bmp_traum;
	}

if (no == 2)
	{
	mtl.skin1 = bmp_balkon;
	}

if (no == 3)
	{
	mtl.skin1 = bmp_bad;
	}

}





function mtl_envmirror_init()
{
  mtl_skin_choice(mtl.skill2);
  
  bmap_to_cubemap(mtl.skin1);
  mtl.event = mtl_envmirror_view;
  mtl.enable_view = on;
}






material mtl_envmirror // environment cube
{
  // skin1 = bmp_reflex;
   
 		
  event = mtl_envmirror_init;
  effect = "
    texture mtlSkin1;
    texture entSkin1;
    matrix matMtl;

    technique envcube
    {
      pass p0
      {

        AddressU[0] = Clamp;  // don't wrap around edges
        AddressV[0] = Clamp;

        TexCoordIndex[0] = CameraSpaceReflectionVector;
        TextureTransformFlags[0] = Count3;
        TextureTransform[0] = <matMtl>; // transform camera space back to world space

        Texture[0] = <mtlSkin1>;
        ColorArg1[0] = Texture;
        ColorArg2[0] = Diffuse;
        // ColorOp[0] = Modulate2x;

        Texture[1] = <entSkin1>;
		TextureFactor = 0xC0FFFFFF;
        ColorArg1[1] = Texture;
        ColorArg2[1] = Current;
		ColorOp[1] = BlendFactorAlpha; // blend by 75% (= oxC0)
      }
    }

    technique fallback { pass p0 { } } // empty fallback causes normal rendering without effect
  ";
}
















action envmirror {
	mtl.skill2 = 0;
	my.material = mtl_envmirror;
	while(1) { my.pan += time; wait(1); }
}

////////////////////////////////////////////////////////////////////////////////
// example for scaling and shifting textures
// using the material matrix:
// u' = u * mtl.matrix11 + v * mtl.matrix21 + mtl.matrix41;
// v' = u * mtl.matrix12 + v * mtl.matrix22 + mtl.matrix42;

// 5-state machine for texture shifting anc scaling
function mtl_rolleye_1();
function mtl_rolleye_5()
{
  mtl.skill2 -= time;		// enlarge eyeball
  if (mtl.skill2 < 100) { mtl.event = mtl_rolleye_1; }
  mtl.matrix11 = floatd(mtl.skill2,100); // u scale
  mtl.matrix22 = mtl.matrix11;           // v scale
}
function mtl_rolleye_4()
{
  mtl.skill2 += time;		// shrink eyeball
  if (mtl.skill2 > 125) { mtl.event = mtl_rolleye_5; }
  mtl.matrix11 = floatd(mtl.skill2,100); // u scale
  mtl.matrix22 = mtl.matrix11;           // v scale
}
function mtl_rolleye_3()
{
  mtl.skill2 -= time;		// enlarge eyeball
  if (mtl.skill2 < 85) { mtl.event = mtl_rolleye_4; }
  mtl.matrix11 = floatd(mtl.skill2,100); // u scale
  mtl.matrix22 = mtl.matrix11;           // v scale
}
function mtl_rolleye_2()
{
  mtl.skill1 -= time;		// shift eyeball right
  if (mtl.skill1 < 0) { mtl.event = mtl_rolleye_3; }
  mtl.matrix41 = floatd(mtl.skill1,500); // u offset
}
function mtl_rolleye_1()
{
  mtl.skill1 += time;		// shift eyeball left
  if (mtl.skill1 > 50) { mtl.event = mtl_rolleye_2; }
  mtl.matrix41 = floatd(mtl.skill1,500); // u offset
}

function mtl_eye_init()
{
// copy standard model material properties
  mtl_copy(mat_model);
  mtl.skill2 = 100; // initial texture scale in percent
  mtl.matrix11 = float(1);	// default u scale
  mtl.matrix22 = float(1);	// default v scale
  mtl.event = mtl_rolleye_1;
  mtl.enable_view = on;
}

material mtl_eye
{
  event = mtl_eye_init;
  effect = "
    matrix matMtl;

    technique scale
    {
// use material transformation matrix, leave everything else at default values
      pass p0
      {
        TextureTransformFlags[0] = Count2;
        TextureTransform[0] = <matMtl>;
      }
    }

	technique fallback { pass p0 { } }
  ";
}






// Chrome
// Conversion by M3PHiSTO (Randy McMillen)
//-----------------------------------------------

material mat_chrome
{
	effect
	"
		matrix matWorldViewProj;
		matrix matWorld;
		matrix matWorldView;
		
		texture entSkin1;
		texture entSkin2;

		technique chrome
		{
			pass p0
			{
				Texture[0] = <entSkin1>;
				Texture[1] = <entSkin2>;

				VertexShaderConstant[0]=<matWorldViewProj>;
				VertexShaderConstant[4]=<matWorld>;//{0f,0f,0f,1f}; // eye
				VertexShaderConstant[5]=<matWorldView>;
				VertexShaderConstant[9]={0f,200f,0f,1f}; //light
				VertexShaderConstant[10]={0f,0.5f,1f,2f}; // common const

				PixelShaderConstant[1]={0f,0f,0f,1f}; // specular
				PixelShaderConstant[2]={1f,1f,1f,1f}; // diffuse

				VertexShader =
				decl
				{
					stream 0;
					float v0[3]; //Position
					float v1[3]; //Normal
					float v2[3]; //Texture Coordinates
					float v3[3]; //Tangent
					float v4[3]; //Binormal
				}
				asm
				{
					vs.1.1

					// output vertex position
					m4x4 oPos, v0, c0

					// output texture coordinates
					mov oT0, v2

					// output normal vector
					mov oT2, v1

					// find the light position in object space
					mov  r0, c9
					m4x4 r1, r0, c5

					// find light vector
					sub  r1, r1, v0

					// normalize light vector
					dp3  r2.x, r1, r1
					rsq  r2.x, r2.x
					mul  r1.xyz, r1.xyz, r2.xxx

					// output light vector
					mov oT1, r1

					// find the eye position in object space
					mov  r0, c4
					m4x4 r2, r0, c5

					// find eye vector
					sub  r2, r2, v0

					// normalize eye vector
					dp3  r3.x, r2, r2
					rsq  r3.x, r3.x
					mul  r2.xyz, r2.xyz, r3.xxx

					// output eye vector
					mov oT4, r2

					// find half angle vector
					add r3, r1, r2
					mul r3, r3, c10.yyy

					// normalize half angle vector
					dp3  r4.x, r3, r3
					rsq  r4.x, r4.x
					mul  r3.xyz, r3, r4.xxx

					mov r3.xy, v1.xy

					// normalize half angle vector
					dp3  r4.x, r3, r3
					rsq  r4.x, r4.x
					mul  r3.xyz, r3, r4.xxx

					// output half angle vector vector
					mov oT3, r3
				};
				PixelShader =
				asm
				{
					ps.1.4

					def c0, 0.0f, 0.0f, 0.0f, 1.0f

					texcrd r0.rgb, t0  // env map
					texcrd r1.rgb, t1  // L
					texcrd r2.rgb, t2  // N
					texcrd r3.rgb, t3  // H
					texcrd r4.rgb, t4  // V

					// N.L
					dp3 r5, r2, r1

					// offset basemap
					mov r0.a, c0.a
					add r0, r0, r5

					// N.H
					dp3 r4.r, r2, r3

					// H.H (aka ||H||^2)
					dp3 r4.g, r3, r3
					mov r4.g, 1-r4.g

					phase

					texld  r1, r4       // N.H^k
					texld  r0, r0       // base

					mul r1.rgb, r1, r5
					mul r1.rgb, r1, c1

					mul r5.rgb, r5, c2
					mul r0.rgb, r5, r0

					add_sat r0, r0, r1
				};
			}
		}
	";
}

ACTION CHROME
{
my.material=mat_chrome;
}


///////////////////////////// jetzt der zweite Mirror //////////////////
function mtl_secondmirror_init()
{
  mtl_skin_choice(2);
  
  bmap_to_cubemap(mtl.skin1);
  mtl.event = mtl_envmirror_view;
  mtl.enable_view = on;
}



material mtl_secondmirror // environment cube
{
  skin1 = bmp_balkon;
   
 		
  event = mtl_secondmirror_init;
  effect = "
    texture mtlSkin1;
    texture entSkin1;
    matrix matMtl;

    technique envcube
    {
      pass p0
      {

        AddressU[0] = Clamp;  // don't wrap around edges
        AddressV[0] = Clamp;

        TexCoordIndex[0] = CameraSpaceReflectionVector;
        TextureTransformFlags[0] = Count3;
        TextureTransform[0] = <matMtl>; // transform camera space back to world space

        Texture[0] = <mtlSkin1>;
        ColorArg1[0] = Texture;
        ColorArg2[0] = Diffuse;
        // ColorOp[0] = Modulate2x;

        Texture[1] = <entSkin1>;
		TextureFactor = 0xC0FFFFFF;
        ColorArg1[1] = Texture;
        ColorArg2[1] = Current;
		ColorOp[1] = BlendFactorAlpha; // blend by 75% (= oxC0)
      }
    }

    technique fallback { pass p0 { } } // empty fallback causes normal rendering without effect
  ";
}


///////////////////////////////////////////////////////////////////////////



///////////////////////////// jetzt der dritte Mirror //////////////////
function mtl_thirdmirror_init()
{
  mtl_skin_choice(2);
  
  bmap_to_cubemap(mtl.skin1);
  mtl.event = mtl_envmirror_view;
  mtl.enable_view = on;
}




material mtl_thirdmirror // environment cube
{
  skin1 = bmp_traum;
   
 		
  event = mtl_thirdmirror_init;
  effect = "
    texture mtlSkin1;
    texture entSkin1;
    matrix matMtl;

    technique envcube
    {
      pass p0
      {

        AddressU[0] = Clamp;  // don't wrap around edges
        AddressV[0] = Clamp;

        TexCoordIndex[0] = CameraSpaceReflectionVector;
        TextureTransformFlags[0] = Count3;
        TextureTransform[0] = <matMtl>; // transform camera space back to world space

        Texture[0] = <mtlSkin1>;
        ColorArg1[0] = Texture;
        ColorArg2[0] = Diffuse;
        // ColorOp[0] = Modulate2x;

        Texture[1] = <entSkin1>;
		TextureFactor = 0xD0FFFFFF;          // wre 91
        ColorArg1[1] = Texture;
        ColorArg2[1] = Current;
		ColorOp[1] = BlendFactorAlpha; // blend by 75% (= oxC0)
      }
    }

    technique fallback { pass p0 { } } // empty fallback causes normal rendering without effect
  ";
}




////////////////////////////////////////////////////////////////////////////



///////////////////////////// jetzt der dritte Mirror //////////////////
function mtl_forthmirror_init()
{
  mtl_skin_choice(3);
  
  bmap_to_cubemap(mtl.skin1);
  mtl.event = mtl_envmirror_view;
  mtl.enable_view = on;
}




material mtl_forthmirror // environment cube
{
  skin1 = bmp_bad;
   
 		
  event = mtl_forthmirror_init;
  effect = "
    texture mtlSkin1;
    texture entSkin1;
    matrix matMtl;

    technique envcube
    {
      pass p0
      {

        AddressU[0] = Clamp;  // don't wrap around edges
        AddressV[0] = Clamp;

        TexCoordIndex[0] = CameraSpaceReflectionVector;
        TextureTransformFlags[0] = Count3;
        TextureTransform[0] = <matMtl>; // transform camera space back to world space

        Texture[0] = <mtlSkin1>;
        ColorArg1[0] = Texture;
        ColorArg2[0] = Diffuse;
        ColorOp[0] = Modulate2x;

        Texture[1] = <entSkin1>;

		// textureFactor=0x40FFFFFF; // -> C0=75%, 80=50%, 40=25%
		TextureFactor = 0x40FFFFFF;
        ColorArg1[1] = Texture;
        ColorArg2[1] = Current;
		ColorOp[1] = BlendFactorAlpha; // blend by 75% (= oxC0)
      }
    }

    technique fallback { pass p0 { } } // empty fallback causes normal rendering without effect
  ";
}




////////////////////////////////////////////////////////////////////////////
bmap pointlight = <pointlight.tga>;
bmap diffspec = <diffspec.tga>;

material mat_diffspecpoint
{
	skin1 = pointlight;
	skin2 = diffspec;
	// event = mat_diffspecpoint_init; 

	flags = tangent;
	effect =
	"
		texture mtlSkin1;		//attenuation map
		texture mtlSkin2;		//diffspec map
		texture entSkin1;
		texture entSkin2;
		matrix matWorldViewProj;
		matrix matWorld;
		vector vecViewPos;
		vector vecSkill41; //light position
		vector mtlSkill1;  //light color
		
		technique specpoint
		{
			pass p0
			{
				
				//load matrices
				VertexShaderConstant[0] = <matWorld>; 	//World Matrix
				VertexShaderConstant[8] = <matWorldViewProj>;	//World*View*Proj Matrix
			 
				//light vector
				VertexShaderConstant[12]  = <vecSkill41>; 
			
					
				//Camera Information
				VertexShaderConstant[16] = <vecViewPos>;
					
				//range constant
				VertexShaderConstant[33] = (0.005f, 0.55f, 0.0f, 0.0f);
				
				//light color
				VertexShaderConstant[40] = <mtlSkill1>;
				
						
				Texture[0]  = <mtlSkin1>; //pointlight attenuation
		  		Texture[1]  = <mtlSkin1>;	//pointlight alpha

         	AddressU[0] = Clamp;  // don't wrap around edges
            AddressV[0] = Clamp;
            AddressU[1] = Clamp;  // don't wrap around edges
            AddressV[1] = Clamp;
				
				zWriteEnable=true; // enables writing to the z-buffer
				AlphaBlendEnable=false; // disables alpha blending 

				VertexShader=
				decl
				{
					stream 0;
					float v0[3]; //position		
					float v3[3]; //normal
					float v7[3]; //uv
					float v8[3]; //tangent
				}
				asm
				{
					vs.1.1
					
					; position in clip space
					m4x4 oPos, v0, c8
				
					; position in world space
					m4x4 r2, v0, c0		
				
					; get light vector
					add r10, r2, -c12
					
					; Divide each component by the range value
					mul r10, r10, c33.x
					
					; multiply with 0.5 and add 0.5
					mad r10, r10, c33.yyyy, c33.yyyy
					
					; map the x and y components into the first texture
					mov oT0.xy, r10.xy
					
					; z-component v0
					mov oT1.x, r10.z
					
				
				};
			
				PixelShader= 
				asm
				{
					
					ps.1.1
					
					tex t0 
					tex t1
					add r0, 1-t0, -t1.a
								
				};
			}
			
			
		pass p1
			{
				
				//load matrices
				VertexShaderConstant[0] = <matWorld>; 	//World Matrix
				VertexShaderConstant[8] = <matWorldViewProj>;	//World*View*Proj Matrix
	
				//light vector
				VertexShaderConstant[12]  = <vecSkill41>; 
	
				//Camera Information
				VertexShaderConstant[16] = <vecViewPos>;

					//range constant
				VertexShaderConstant[33] = (1.05f, 0.5f, 0f, 0.0f);

				//light color
				VertexShaderConstant[40] = <mtlSkill1>;
							
				Texture[0]   = <entSkin1>;
		  		Texture[1]   = <entSkin2>;
				Texture[3]   = <mtlSkin2>;
				
            AddressU[3] = Clamp;  // don't wrap around edges
            AddressV[3] = Clamp;
				
				zWriteEnable=true; // enables writing to the z-buffer
				AlphaBlendEnable=true; // enable alpha blending 
    			
				SrcBlend = zero;        
				DestBlend = SrcColor;			

				VertexShader=
				decl
				{
					stream 0;
					float v0[3]; //position		
					float v3[3]; //normal
					float v7[3]; //uv
					float v8[3]; //tangent
		
				}
				asm
				{
					vs.1.1
					; position in clip space
					m4x4 oPos, v0, c8
					
					m3x3 r3, v8, c0	; generate tangent U
					m3x3 r5, v3, c0	; generate normal W
					
					; Cross product
					; generate binormal V
					mul r0, -r3.zxyw, r5.yzxw  ;
					mad r4, -r3.yzxw, r5.zxyw,-r0 ;
					
					; position in world space
					m4x4 r2, v0, c0			
					
					; get light vector
					add r10, r2, -c12
					
					; normalize light vector
					; always first normalize than transform
					dp3 r11.x, r10.xyz, r10.xyz		
					rsq r11.xyz, r11.x			
					mul r10.xyz, r10.xyz, r11.xyz	
					
					;transform the light vector with U, V, W
					dp3 oT2.x, r3, -r10
					dp3 oT2.y, r4, -r10
					dp3 oT2.z, r5, -r10				
					
					;position in world space			
					m4x4 r6, v0, c0

					; get a vector toward the camera/eye V
					add r6, r6, -c16
					
					; normalize eye vector V
					dp3 r8.x, r6.xyz, r6.xyz	
					rsq r8.xyz, r8.x			
					mul r6.xyz, r6.xyz, r8.xyz	
					
					add r6, r6, r10	;
					mul r6,r6,c33.y	;V+L / 2 --half vector
					
					; normalize half angle
					dp3 r8.x, r6.xyz, r6.xyz		
					rsq r8.xyz, r8.x			
					mul r6.xyz, r6.xyz, r8.xyz	
					
					//raise the specular power
					mul r6, r6, c33.x	
					
					; transform the half angle vector into texture space
					dp3 oT3.x,r3,-r6
					dp3 oT3.y,r4,-r6
					dp3 oT3.z,r5,-r6
						
					;output uvs 						  	  
					mov oT0.xy, v7.xy
					mov oT1.xy, v7.xy
					
					;output light color
					mov oD0,c40
	
				};
			
				PixelShader= 
				asm
				{
					ps.1.1
					
					tex t0					; color map in t0.rgb + specular map in t0.a
					tex t1					; normal map
					texm3x2pad t2, t1_bx2   ; u = t1 dot (t2) light vector
					texm3x2tex t3, t1_bx2   ; v = t1 dot (t3) half vector
											; fetch texture 4 at u, v
											; t3.rgb = (N dot L)
											; t3.a = (N dot H)^16
					
					; r0 = (diffuse * color) + ((N dot H)^16 * specular value)
					mul r1.rgb, t3, t0	; (N dot L) * base texture
					+mul_x4 r1.a, t0.a, t3.a   ; (N dot H)^16 * specular value		
					add r0, r1.a, r1
					
					mul_x4 r0,r0,v0 ; modulate against light color
						
				};
			}
			
		}
	";
} 



// and here is the entity action i use to pass light data.. 
// note that currently you cant pass light positions objects in the map... but i am working on that..
// also note that if you use this shader on everything and make your world out of models/terrains, you have no need at all of WED light entities, and thus the 8-light limit isnt a problem!


ACTION worldmodel
{
	MY.passable=OFF;
	MY.shadow=ON;
	my.flare=off;
	my.transparent=off;

	my.skill41=float(-320); 	//x   
	my.skill42=float(32); 		//z   
	my.skill43=float(-224);  	//y	
	my.skill44=float(1);

	my.skill51=100; //R	
	my.skill52=100; //G		
	my.skill53=100; //B	 
	
	mat_diffspecpoint.skill1 = pixel_for_vec(vector(my.skill53,my.skill52,my.skill51),100,8888);
	
	MY.material= mat_diffspecpoint;	
				
}  




//-----------------------------------------------------------------------------
// Name: 
// Desc: 
//-----------------------------------------------------------------------------

material mat_pointlight //change the name in the Texture name, if you want to use it for levelgeometrie
{
ambient_blue = 133;
ambient_green = 33;
ambient_red = 33;
emissive_red = 99;
emissive_green = 77;
emissive_blue = 77;
diffuse_blue = 200;
specular_green = 255;
specular_blue = 255;

power = 1;

effect="
DWORD wfcolor = 0xFFFFFFFF; // Change this to the wireframe color of your choice

texture tex0;        // First texture
texture tex1;        // Second texture


technique mat_pointlight
{
pass p0
{
Texture[0] = <tex0>;
ColorOp[0] = SelectArg1;
ColorArg1[0] = Texture;

Texture[1] = <tex1>;
//ColorOp[1] = Subtract;
ColorOp[1] = Modulate2x;

ColorArg1[1] = Texture;
ColorArg2[1] = Current;
		
ColorOp[2] = Disable;



}
}
";


}






//-----------------------------------------------------------------------------
// Name: 
// Desc: 
//-----------------------------------------------------------------------------


material wireframe //change the name in the Texture name, if you want to use it for levelgeometrie
{
effect="
DWORD wfcolor = 0xFFFFFFFF; // Change this to the wireframe color of your choice
technique wireframe
{
pass p0
{
TextureFactor = <wfcolor>;
// CullMode = None; // Uncomment if you want backface too.
FillMode = Wireframe;
ColorOp[0] = SelectArg1;
ColorArg1[0] = TFactor;




}
}
";
}




action MyWireframe
{
my.material = wireframe;

}



////////////////////////////////////////////////////////////////////////
function mtl_water_init()
{
  //bmap_to_cubemap(mtl.skin4);
//  bmap_to_uv(bmap_for_entity(my,2));
  mtl.event = mtl_env_view;
  mtl.enable_view = on;
}



material mat_beach
 {
 	event=mtl_water_init;
 	skin1=bmp_pool;
 	skin2=bmp_caustic;
 	skin3=bmp_envcube;
 	scale2=2;

	effect=
	"
    texture entSkin1;
    texture entSkin2;
    texture mtlSkin3;
    matrix matMtl;
    matrix matWorldView;
 

    technique envcube
    {
      pass p0
      {
        Lighting       = True;
        SpecularEnable = True;
		  alphatestenable=true;
			
		  ADDRESSU[0]=wrap;
		  ADDRESSV[0]=wrap;
		  ADDRESSU[1]=wrap;
		  ADDRESSV[1]=wrap;
		  ADDRESSU[2]=wrap;
		  ADDRESSV[2]=wrap;
   
   
		 // Stage0
        MinFilter[0] = Linear;
        MagFilter[0] = Linear;
        MipFilter[0] = Point;

        Texture[0] = <entSkin1>;         
        ColorOp[0]   = BLENDTEXTUREALPHA;
        ColorArg1[0] = Texture;

         // Stage1
        MinFilter[1] = Linear;
        MagFilter[1] = Linear;
        MipFilter[1] = Point;
     
        Texture[1]   = <entSkin2>;
        ColorOp[1]   = bumpenvmap;
        ColorArg1[1] = Texture;
        ColorArg2[1] = current;


        // Stage2
        MinFilter[2] = Linear;
        MagFilter[2] = Linear;
        MipFilter[2] = Point;

        Texture[2] = <mtlSkin3>;
        TextureTransform[2] = <matMtl>;
        TextureTransformFlags[2] = Count3;
        TexCoordIndex[2] = cameraspacereflectionvector;
        
        ColorOp[2]   = modulate;
        ColorArg1[2] = Texture;
        ColorArg2[2] = Current;
        AlphaOp[2]   = SelectArg2;
        AlphaArg2[2] = Current;
     
		}
		
	}
";
 } 







function mtl_addition_init()
{
  mtl.event = mtl_env_view;
  mtl.enable_view = on;
  mtl.alpha = 70;
}





material mat_addition
 {
	

 	event=mtl_addition_init;
 	skin1=bmp_pool;
 	skin2=bmp_caustic;
 	scale2=2;

	effect=
	"
    texture entSkin1;
    texture entSkin2;
    matrix matMtl;
    matrix matWorldView;
 

    technique addition
    {
      pass p0
      {
        Lighting       = True;
        SpecularEnable = True;
		alphatestenable=true;
			
		ADDRESSU[0]=wrap;
		ADDRESSV[0]=wrap;
		ADDRESSU[1]=wrap;
		ADDRESSV[1]=wrap;
   

		 // Stage0
        MinFilter[0] = Linear;
        MagFilter[0] = Linear;
        MipFilter[0] = Point;

        Texture[0] = <entSkin1>;         
        ColorOp[0]   = BLENDTEXTUREALPHA;
        ColorArg1[0] = Texture;

		////////////// neu hinzugefgt
        TexCoordIndex[0] = CameraSpaceReflectionVector;
        TextureTransform[0] = <matMtl>; // transform camera space back to world space
		/////////////////////////////////////////////


         // Stage1
        MinFilter[1] = Linear;          // war Linear
        MagFilter[1] = Linear;
        MipFilter[1] = Point;
     
        Texture[1]   = <entSkin2>;
        ColorOp[1]   = bumpenvmap;
        ColorArg1[1] = Texture;
        ColorArg2[1] = current;
   
		}
		
	}
";
 } 



