///////////////////////////////////////////////////////////////////////////////////
// A5 main wdl
////////////////////////////////////////////////////////////////////////////
// Files to over-ride:
// * logodark.bmp - the engine logo, include your game title
// * horizon.pcx - A horizon map displayed over the sky and cloud maps
////////////////////////////////////////////////////////////////////////////
// The PATH keyword gives directories where game files can be found,
// relative to the level directory
path "C:\\PROGRAMME\\GSTUDIO6\\template";	// Path to WDL templates subdirectory
path "PanelPic";
path "Maps";
path "models";
path "environment";
path "WaveFiles";
path "WaveFiles";
path "CommandPrefabs";


// define FULL_VERSION;


ifdef FULL_VERSION;
// bind <SmartTalkingNodes.exe>;
endif;


////////////////////////////////////////////////////////////////////////////
// The INCLUDE keyword can be used to include further WDL files,
// like those in the TEMPLATE subdirectory, with prefabricated actions
include <movement.wdl>;
include <messages.wdl>;
include <menu.wdl>;		// must be inserted before doors and weapons
include <particle.wdl>; // remove when you need no particles
include <doors.wdl>;		// remove when you need no doors
include <actors.wdl>;   // remove when you need no actors
include <weapons.wdl>;  // remove when you need no weapons
include <war.wdl>;      // remove when you need no fighting
//include <venture.wdl>;	// include when doing an adventure
// include <lflare.wdl>;   // remove when you need no lens flares

/* -------------------- when you use Newton
include <newton.wdl>;
include <newtonScript2.wdl>;
*/


include <Shader.wdl>;
//////////////////////// embedding the particle system
include <Materialien.wdl>;
include <definitions.wdl>;
include <TinyThings.wdl>;
include <ThirtySounds.wdl>;

include <SmartNodes.wdl>;
include <SmartFunctions.wdl>;


///////////////////////// eax /////////////////////////////////






////////////////////////////////////////////////////////////////////////////
// The engine starts in the resolution given by the follwing vars.
var video_mode =	8;	 // screen size 640x480
var video_depth =	16; // 16 bit colour D3D mode



/////////////////////////////////////////////////////////////////
// Strings and filenames
// change this string to your own starting mission message.
string mission_str = "Fight your way through the level. Press [F1] for help";
// string level_str = <Apartment.WMB>; // give file names in angular brackets


string level_str = <Terminal.WMB>;
// string level_str = <Demo.WMB>; // give file names in angular brackets

bind <Demo.wmb>;

ifdef FULL_VERSION;
// bind <Lobby.WMB>; 
// bind <Cellar.WMB>; 
endif;





/////////////////////////////////////////////////////////////////
// define a splash screen with the required A4/A5 logo
bmap splashmap = <logodark.pcx>; // the default logo in templates
panel splashscreen {
	bmap = splashmap;
	flags = refresh,d3d;
}





////////////////////////////////////////////////////////////////////////////
// The following script controls the sky

dllfunction EphemerLoop(void_var);




function General_Loop()
{
if (ImGame == 0)
	{
	NodesLoop(0);        // calls DLL
	AudioLoop(0);
	wait(1);
	General_Loop();
	}
}








/////////////////////////////////////////////////////////////////
// The main() function is started at game start
function main()
{
// set some common flags and variables
//	warn_level = 2;	// announce bad texture sizes and bad wdl code
	tex_share = ON;	// map entities share their textures


	// PlayOpening();

// center the splash screen for non-640x480 resolutions, and display it
	splashscreen.pos_x = (screen_size.x - bmap_width(splashmap))/2;
	splashscreen.pos_y = (screen_size.y - bmap_height(splashmap))/2;
	splashscreen.visible = ON;
// wait 3 frames (for triple buffering) until it is flipped to the foreground
	wait(3);

// now load the level
	level_load(level_str);



/*  when you use Newton
ifdef USE_NEWTON_GAME_DYNAMICS;	
	wait(1);
	dll_handle = newtonHandle;
	NewtonAddMap (level_str, splashscreen);
endif;	
*/




// freeze the game
	freeze_mode = 1;

// wait the required second, then switch the splashscreen off.
	sleep(1);
  	splashscreen.visible = OFF;
	bmap_purge(splashmap);	// remove splashscreen from video memory

// load some global variables, like sound volume
	load_status();

// display the initial message
	msg_show(mission_str,10);

// initialize lens flares when edition supports flares
/*
ifdef caps_flare;
	lensflare_start();
endif;
*/


// use the new 3rd person camera
	move_view_cap = 1;

// un-freeze the game
	freeze_mode = 0;

//	client_move();	// for a possible multiplayer game
// call further functions here...

	// NodesStartup();
	
	fps_max			=	60;


	/*
	TinyThingsMode = 0;
	dll_handle = partikel_handle;
	partikel_handle = dll_open("TinyThings.dll");
	TinyThingsInit();
	*/
	// TinyThingsPlayback();

	///////////////// SmartNodes 
	// fog_color = 4;	
	camera.arc = 80;

	dll_handle = nodes_handle;
	nodes_handle = dll_open("SmartNodes.dll");
    
	InitFonts(0);       // hier wird u.a. auch der Opening getriggered
	// wait(5);			// deshalb die Pause


	TinyThingsMode = 0;
	TinyThingsPlayback(0);

	eax_flag = 1;                    // 0 heit - keine Initialisierung
	InitSoundMachine();
	InitGame("ThirtyMinutes");
	///////////////////////// This is the loop
	General_Loop();


}



sky sky_cube {
	type = <skycube2+6.bmp>;
	flags = cube,visible;
	layer = 2;
}



/////////////////////////////////////////////////////////////////
// The following definitions are for the pro edition window composer
// to define the start and exit window of the application.
window WINSTART
{
	title			"3D GameStudio";
	size			480,320;
	mode			IMAGE;	//STANDARD;
	bg_color		RGB(240,240,240);
	frame			FTYP1,0,0,480,320;
//	BUTTON		BUTTON_START,SYS_DEFAULT,"Start",400,288,72,24;
	button		BUTTON_QUIT,SYS_DEFAULT,"Abort",400,288,72,24;
	TEXT_STDOUT	"Arial",RGB(0,0,0),10,10,460,280;
}

/* no exit window at all..
window WINEND
{
	title			"Finished";
	size			540,320;
	mode	 		STANDARD;
	bg_color		RGB(0,0,0);
	TEXT_STDOUT	"",RGB(255,40,40),10,20,520,270;

	SET font		"",RGB(0,255,255);
	text			"Any key to exit",10,270;
}*/



dllfunction AssignPlayer(ent);


function MyHeroEvent()
{
if (event_type == event_stuck)
	{
	//beep;
	// my.passable = ON;
	}
}



action MyHero
{
my.enable_scan		= on;
my.enable_detect	= on;
my.enable_stuck		= on;
my.event            = MyHeroEvent;

my.narrow			= on;
my.fat				= off;

my.skill35 = 9999;               // fr RenderArealManager

if	(you == null)
	{
	player = my;
	
	}


player_walk();



AssignPlayer(my);
}







panel texturspeicher
{
  pos_X = 0; pos_y = 0;
  digits = 0, 0, 5, digit_font, 1,num_particles; // zeige Anzahl der Partikel 
  flags = REFRESH;
}


//////////////////////// Thirty Minutes Game ////////////////////







bmap gaugepic = <Gauge3.bmp>; // 
bmap Knopf	  = <Knopf.tga>;
bmap Tafel	  = <Tafel.bmp>;
bmap Tafel2	  = <Tafel2.bmp>;
bmap Tafel3	  = <Tafel3a.bmp>;
bmap Tape	  = <RunningTape.bmp>;

bmap aover    =		<ArrowOVER.bmp>;
bmap aoff     =		<ArrowOFF.bmp>;
bmap aon      =		<ArrowON.bmp>;

bmap adover    =		<ArrowdOVER.bmp>;
bmap adoff     =		<ArrowdOFF.bmp>;
bmap adon      =		<ArrowdON.bmp>;


bmap bon      =		<KlappON.bmp>;
bmap bover    =		<KlappOVER.bmp>;
bmap boff	  =		<KlappOFF.bmp>;

bmap bon2      =	<KlappON2.bmp>;
bmap bover2    =	<KlappOVER2.bmp>;
bmap boff2	  =		<KlappOFF2.bmp>;


bmap rlight		=		<lightwindow.tga>;
bmap inventory	=		<InventoryWindow.tga>;


dllfunction ShowGameText(void_var);
dllfunction DiaryDown(void_var);
dllfunction DiaryUp(void_var);
//-----------------------------------------------------------------------------
// Name: 
// Desc: das Panel fr SmartTextes
//-----------------------------------------------------------------------------

bmap Cover = <Cover.bmp>; // 


panel FullScreenPanel
{
layer = 10;
on_click = HideCover;
bmap Cover;

flags visible, overlay, refresh;
}

dllfunction TransmitFullscreenState(void_var);


function HideCover()
{
TransmitFullscreenState(0);
FullScreenPanel.visible = off;
}


function ShowCover()
{
FullScreenPanel.alpha = 100;
FullScreenPanel.visible = on;
}


function DisplayCover()
{
FullScreenPanel.visible = on;
}


function MakeTransparentCover()
{
FullScreenPanel.transparent = on;
}


function TransparentCover()
{
FullScreenPanel.transparent = on;
FullScreenPanel.alpha = 100;
}

//-----------------------------------------------------------------------------
// Name: 
// Desc: das Terminal-Panel
//-----------------------------------------------------------------------------
BMAP BildPlatz4,<BildPlatz4.bmp>; 
BMAP BildPlatz4a,<BildPlatz4a.bmp>; 

BMAP BildPlatz60,<BildPlatz60.bmp>; 
BMAP BildPlatz61,<BildPlatz61.bmp>; 
BMAP BildPlatz62,<BildPlatz62.bmp>; 
BMAP BildPlatz63,<BildPlatz63.bmp>; 
BMAP BildPlatz64,<BildPlatz64.bmp>; 
BMAP BildPlatz65,<BildPlatz65.bmp>; 
BMAP BildPlatz66,<BildPlatz66.bmp>; 
BMAP BildPlatz67,<BildPlatz67.bmp>; 


dllfunction TransmitTerminalState(void_var);
dllfunction LoadSavedGame(var);



panel TerminalPanel
{
layer = 9;
on_click = HideTerminalPanel;
bmap Cover;

BUTTON 22, 22, BildPlatz4a, BildPlatz4, BildPlatz4a,  LoadStoredGame, NULL, NULL;
BUTTON 22, 142, BildPlatz4a, BildPlatz4, BildPlatz4a, LoadStoredGame, NULL, NULL;
BUTTON 22, 262, BildPlatz4a, BildPlatz4, BildPlatz4a, LoadStoredGame, NULL, NULL;
BUTTON 22, 382, BildPlatz4a, BildPlatz4, BildPlatz4a, LoadStoredGame, NULL, NULL;
BUTTON 22, 502, BildPlatz4a, BildPlatz4, BildPlatz4a, LoadStoredGame, NULL, NULL;
BUTTON 22, 622, BildPlatz4a, BildPlatz4, BildPlatz4a, LoadStoredGame, NULL, NULL;

/*
BUTTON 32, 50,  BildPlatz4a, BildPlatz4, BildPlatz4a, NULL, NULL, NULL;
BUTTON 32, 140, BildPlatz4a, BildPlatz4, BildPlatz4a, NULL, NULL, NULL;
BUTTON 32, 230, BildPlatz4a, BildPlatz4, BildPlatz4a, NULL, NULL, NULL;
BUTTON 32, 320, BildPlatz4a, BildPlatz4, BildPlatz4a, NULL, NULL, NULL;
BUTTON 32, 410, BildPlatz4a, BildPlatz4, BildPlatz4a, NULL, NULL, NULL;
BUTTON 32, 500, BildPlatz4a, BildPlatz4, BildPlatz4a, NULL, NULL, NULL;
BUTTON 32, 590, BildPlatz4a, BildPlatz4, BildPlatz4a, NULL, NULL, NULL;
BUTTON 32, 680, BildPlatz4a, BildPlatz4, BildPlatz4a, NULL, NULL, NULL;
*/

BUTTON 24, 24,  BildPlatz60, BildPlatz60, BildPlatz60, NULL, NULL, NULL;
BUTTON 24, 144, BildPlatz61, BildPlatz61, BildPlatz61, NULL, NULL, NULL;
BUTTON 24, 264, BildPlatz62, BildPlatz62, BildPlatz62, NULL, NULL, NULL;
BUTTON 24, 384, BildPlatz63, BildPlatz63, BildPlatz63, NULL, NULL, NULL;
BUTTON 24, 504, BildPlatz64, BildPlatz64, BildPlatz64, NULL, NULL, NULL;
BUTTON 24, 624, BildPlatz65, BildPlatz65, BildPlatz65, NULL, NULL, NULL;
//BUTTON 24, 592, BildPlatz66, BildPlatz66, BildPlatz66, NULL, NULL, NULL;
// BUTTON 24, 682, BildPlatz67, BildPlatz67, BildPlatz67, NULL, NULL, NULL;


flags visible, refresh, overlay;
}


function LoadStoredGame(no)
{
	if (no == 2)	{
						beep;
						}

	LoadSavedGame(no);
}




function HideTerminalPanel
{
TransmitTerminalState(0);
TerminalPanel.visible = off;
}


function ShowTerminalPanel
{
TerminalPanel.visible = on;
}


//-----------------------------------------------------------------------------
// Name: 
// Desc: das Panel fr SmartTextes
//-----------------------------------------------------------------------------

panel Texttafel
{
on_click = HideTafel;
pos_x 112;
pos_y 100;                    // war 100
bmap Tafel;
layer 1;
button 0, 300, bon2, boff2, bover2, null, null, null;

flags visible, overlay, refresh, transparent;
}


//-----------------------------------------------------------------------------
// Name: 
// Desc: das Panbel fr SmartDialoges
//-----------------------------------------------------------------------------

panel DialogTafel
{
on_click = HideDialogTafel;
pos_x 112;
pos_y 100;                    // war 100
bmap Tafel2;
layer 1;

button 0, 300, bon2, boff2, bover2, null, null, null;

flags overlay, refresh, transparent;
}



//-----------------------------------------------------------------------------
// Name: Buch
// Desc: das Panbel frs Buch
//-----------------------------------------------------------------------------
bmap Buchleer	  = <EmptyBook2.bmp>;
bmap Zeitung      = <Zeitung.bmp>;

panel BuchTafel
{
on_click = HideBuchTafel;
pos_x 112;
pos_y 100;                    // war 100
bmap Buchleer;
layer 1;

button 0, 300, bon2, boff2, bover2, null, null, null;

flags overlay, refresh, transparent;
}


function HideBuchTafel()
{
Buchtafel.visible = off;
}

function bookpanelcheck()
{
if (BuchTafel.visible == OFF)
	{
	BuchTafel.alpha = 70;
	BuchTafel.visible = ON;
	}
else
	{
	BuchTafel.visible = OFF;
	}
}


//-----------------------------------------------------------------------------
// Name: Newspaper
// Desc: das Panbel fr die Zeitung
//-----------------------------------------------------------------------------
panel ZeitungsTafel
{
on_click = HideZeitungsTafel;
pos_x 112;
pos_y 100;                    // war 100
bmap Zeitung;
layer 1;

// button 0, 300, bon2, boff2, bover2, null, null, null;

flags refresh, visible, transparent;
}


function ZeigeZeitung()
{
ZeitungsTafel.alpha = 75;
ZeitungsTafel.visible = on;
}


function HideZeitungsTafel()
{
ZeitungsTafel.visible = off;
}


function SwitchZeitung()
{
if (ZeitungsTafel.visible == OFF)
	{
	ZeitungsTafel.alpha = 75;
	ZeitungsTafel.visible = ON;
	}
else
	{
	ZeitungsTafel.visible = OFF;
	}
}




//-----------------------------------------------------------------------------
// Name: 
// Desc: das Panbel fr SmartDialoges
//-----------------------------------------------------------------------------
dllfunction DiaryPanelPrivileg(void_var);


var textpos = 55;

panel DiaryTafel
{
on_click = HideDiaryTafel;
button 0, 395, aon, aoff, aover, Increase, StopIncrease, null;
button 0, 415, adon, adoff, adover, Increase, StopIncrease, null;
pos_x 112;
pos_y 100;                    // war 100
bmap Tafel3;
layer 1;



flags refresh;
}


var forward;
var backward;

function Increase(buttonNr)
{
	if (buttonNr == 1)
		{
		backward = 1;
		while(backward == 1)
			{
			DiaryUp(0);
			wait(2);
			}
		}
	


	if (buttonNr == 2)
		{
		forward = 1;
		while(forward == 1)
			{
			DiaryDown(0);
			wait(2);
			}
		}

}



function StopIncrease(buttonNr)
{
if (buttonNr == 1) 
	{
	backward = 0;
	}

if (buttonNr == 2) 
	{
	forward = 0;
	}


}




function HideTafel()
{
Texttafel.visible = OFF;
}

function HideDialogTafel()
{
DialogTafel.visible = OFF;

}


function HideDiaryTafel()
{
DiaryTafel.visible = OFF;
}



function diarycheck()
{
if (DiaryTafel.visible == ON)
	{
	//DiaryTafel.alpha = 80;
	DiaryTafel.visible = OFF;
	}
else
	{
	TextTafel.visible = OFF;
	DialogTafel.visible = OFF;
	DiaryTafel.visible = ON;
	DiaryPanelPrivileg();
	}
}



function tafelcheck()
{
if (Texttafel.visible == ON)
	{
	Texttafel.alpha = 60;
	Texttafel.visible = OFF;
	}
else
	{
	DiaryTafel.visible = OFF;
	Texttafel.visible = ON;
	}
}


function dialogcheck()
{
if (DialogTafel.visible == ON)
	{
	DialogTafel.alpha =		70;
	DialogTafel.visible =	OFF;
	}
else
	{
	if (Texttafel.visible == ON)
		{
		Texttafel.visible = OFF;
		DiaryTafel.visible = OFF;
		}
	DialogTafel.visible = ON;
	}
}




var gwindow = 0;
var hwindow = 0;


panel Gauge
{
pos_x 112;         // war vorher 112
pos_y 542;
bmap gaugepic;
layer 1;
button 10, 0, bon, boff, bover, OMON, null, null;          // war tafelcheck
button 300, 0, bon, boff, bover, diarycheck, null, null;
button 0, 10, bon2, boff2, bover2, gaugecheck, null, null;

window 760, 20, 12, 12, rlight, gwindow, 0;
window 200, 171, 400, 2, tape, hwindow, 0;

// button 700, 20, rlight, rlight, rlight, tafelcheck, null, null;
flags visible, overlay, refresh;
}





panel GaugeON
{
on_click = RestoreGauge;
pos_x 10;
pos_y 710;
bmap knopf;
layer 1;
flags overlay, refresh;
}


function GaugeON_invisible()
{
GaugeON.visible = off;
}

function GaugeON_visible()
{
GaugeON.visible = on;
}






function RestoreGauge()
{
GaugeON.visible = OFF;
Gauge.visible = ON;
}




////////////////////////////////////////////////////////////////
bmap Menu,		<Menu.tga>; 
bmap Marker,	<Marker.tga>; 
BMAP CircleWhite,<CircleWhite.bmp>; 
BMAP CircleOrange,<CircleOrange.bmp>; 
BMAP CircleGray,<CircleGray.bmp>; 

panel AktionsMenu
{
on_click = HideAktionsMenu;
pos_x -1000;         
pos_y 553;
bmap Menu;

BUTTON 10, 6, CircleWhite, CircleGray, CircleOrange, MenuTriggered, MenuTriggeredOff, MenuTriggeredOver;
BUTTON 10, 23, CircleWhite, CircleGray, CircleOrange, MenuTriggered, MenuTriggeredOff, MenuTriggeredOver;
BUTTON 10, 40, CircleWhite, CircleGray, CircleOrange, MenuTriggered, MenuTriggeredOff, MenuTriggeredOver;
BUTTON 10, 57, CircleWhite, CircleGray, CircleOrange, MenuTriggered, MenuTriggeredOff, MenuTriggeredOver;
BUTTON 10, 74, CircleWhite, CircleGray, CircleOrange, MenuTriggered, MenuTriggeredOff, MenuTriggeredOver;
BUTTON 10, 91, CircleWhite, CircleGray, CircleOrange, MenuTriggered, MenuTriggeredOff, MenuTriggeredOver;
BUTTON 10, 108, CircleWhite, CircleGray, CircleOrange, MenuTriggered, MenuTriggeredOff, MenuTriggeredOver;
BUTTON 10, 124, CircleWhite, CircleGray, CircleOrange, MenuTriggered, MenuTriggeredOff, MenuTriggeredOver;
/*
BUTTON 15, 177, CircleWhite, CircleGray, CircleOrange, MenuTriggered, NULL, NULL;
BUTTON 15, 197, CircleWhite, CircleGray, CircleOrange, MenuTriggered, NULL, NULL;
BUTTON 15, 217, CircleWhite, CircleGray, CircleOrange, MenuTriggered, NULL, NULL;
*/
layer = 5;
flags visible, refresh, d3d;   
};


dllfunction HideAktionsMenu(void_var);



function AktionsMenuON()
{
AktionsMenu.visible = ON;
}

function AktionsMenuOFF()
{
beep;
AktionsMenu.visible = off;
}







dllfunction MenuTriggered(var);
dllfunction MenuTriggeredOver(var);
dllfunction MenuTriggeredOff(var);


////////////////////////////////////////////////////////////////
var om_pan  = 0;
var om_tilt = 0;

dllfunction ObjetManipulator(var, var, var);


bmap mat	= <Material.bmp>; 
bmap areal  = <Areal.tga>;
BMAP BildPlatz3,<BildPlatz3a.bmp>; 
BMAP remove,<removeON.tga>; 

//bmap vslide = <vslide.tga>; //
//bmap hslide = <hslide.tga>; //

var inv1	= 0;
var inv2	= 0;
var inv3	= 0;
var inv4	= 0;
var inv5	= 0;
var inv6	= 0;
var inv7	= 0;
var inv8	= 0;
var inv9	= 0;
var inv10	= 0;
var inv11	= 0;
var inv12	= 0;
var inv13	= 0;
var inv14	= 0;
var inv15	= 0;
var inv16	= 0;


var mk1	= 0;
var mk2	= 0;
var mk3	= 0;
var mk4	= 0;
var mk5	= 0;
var mk6	= 0;
var mk7	= 0;
var mk8	= 0;
var mk9	= 0;
var mk10	= 0;
var mk11	= 0;
var mk12	= 0;
var mk13	= 0;
var mk14	= 0;
var mk15	= 0;
var mk16	= 0;



panel ObjektManipulation
{
pos_x 123;         
pos_y 553;
bmap mat;
layer = 4;

BUTTON 180, 9, BildPlatz3, BildPlatz3, BildPlatz3, InventoryTriggered, InventoryTriggeredOFF, InventoryTriggeredOver;
window 182, 11, 60, 60, inventory, inv1, 0;
window 182, 11, 60, 60, Marker, mk1, 0;             // fr den Marker

BUTTON 180, 80, BildPlatz3, BildPlatz3, BildPlatz3, InventoryTriggered, InventoryTriggeredOFF, InventoryTriggeredOver;
window 182, 82, 60, 60, inventory, inv2, 0;
window 182, 82, 60, 60, Marker, mk2, 0;    

BUTTON 256, 9, BildPlatz3, BildPlatz3, BildPlatz3, InventoryTriggered, InventoryTriggeredOFF, InventoryTriggeredOver;
window 258, 11, 60, 60, inventory, inv3, 0;
window 258, 11, 60, 60, Marker, mk3, 0;    

BUTTON 256, 80, BildPlatz3, BildPlatz3, BildPlatz3, InventoryTriggered, InventoryTriggeredOFF, InventoryTriggeredOver;
window 258, 82, 60, 60, inventory, inv4, 0;
window 258, 82, 60, 60, Marker, mk4, 0;    

BUTTON 330, 9, BildPlatz3, BildPlatz3, BildPlatz3, InventoryTriggered, InventoryTriggeredOFF, InventoryTriggeredOver;
window 332, 11, 60, 60, inventory, inv5, 0;
window 332, 11, 60, 60, Marker, mk5, 0;    

BUTTON 330, 80, BildPlatz3, BildPlatz3, BildPlatz3, InventoryTriggered, InventoryTriggeredOFF, InventoryTriggeredOver;
window 332, 82, 60, 60, inventory, inv6, 0;
window 332, 82, 60, 60, Marker, mk6, 0;    

BUTTON 402, 9, BildPlatz3, BildPlatz3, BildPlatz3, InventoryTriggered, InventoryTriggeredOFF, InventoryTriggeredOver;
window 404, 11, 60, 60, inventory, inv7, 0;
window 404, 11, 60, 60, Marker, mk7, 0;    

BUTTON 402, 80, BildPlatz3, BildPlatz3, BildPlatz3, InventoryTriggered, InventoryTriggeredOFF, InventoryTriggeredOver;
window 404, 83, 60, 60, inventory, inv8, 0;
window 404, 83, 60, 60, Marker, mk8, 0;    


BUTTON 476, 9, BildPlatz3, BildPlatz3, BildPlatz3, InventoryTriggered, InventoryTriggeredOFF, InventoryTriggeredOver;
window 478, 11, 60, 60, inventory, inv9, 0;
window 478, 11, 60, 60, Marker, mk9, 0;    

BUTTON 476, 80, BildPlatz3, BildPlatz3, BildPlatz3, InventoryTriggered, InventoryTriggeredOFF, InventoryTriggeredOver;
window 478, 82, 60, 60, inventory, inv10, 0;
window 478, 82, 60, 60, Marker, mk10, 0;    

BUTTON 550, 9, BildPlatz3, BildPlatz3, BildPlatz3, InventoryTriggered, InventoryTriggeredOFF, InventoryTriggeredOver;
window 552, 11, 60, 60, inventory, inv11, 0;
window 552, 11, 60, 60, Marker, mk11, 0;    

BUTTON 550, 80, BildPlatz3, BildPlatz3, BildPlatz3, InventoryTriggered, InventoryTriggeredOFF, InventoryTriggeredOver;
window 552, 82, 60, 60, inventory, inv12, 0;
window 552, 82, 60, 60, Marker, mk12, 0;    

BUTTON 624, 9, BildPlatz3, BildPlatz3, BildPlatz3, InventoryTriggered, InventoryTriggeredOFF, InventoryTriggeredOver;
window 626, 11, 60, 60, inventory, inv13, 0;
window 626, 11, 60, 60, Marker, mk13, 0;    

BUTTON 624, 80, BildPlatz3, BildPlatz3, BildPlatz3, InventoryTriggered, InventoryTriggeredOFF, InventoryTriggeredOver;
window 626, 82, 60, 60, inventory, inv14, 0;
window 626, 82, 60, 60, Marker, mk14, 0;    

BUTTON 698, 9, BildPlatz3, BildPlatz3, BildPlatz3, InventoryTriggered, InventoryTriggeredOFF, InventoryTriggeredOver;
window 700, 11, 60, 60, inventory, inv15, 0;
window 700, 11, 60, 60, Marker, mk15, 0;    

BUTTON 698, 80, BildPlatz3, BildPlatz3, BildPlatz3, InventoryTriggered, InventoryTriggeredOFF, InventoryTriggeredOver;
window 700, 82, 60, 60, inventory, inv16, 0;
window 700, 82, 60, 60, Marker, mk16, 0;    

button 19, 20, Areal, Areal, Areal, TriggerManipulate, TriggerManipulateOff, Manipulate;


flags visible, refresh, d3d;   
};




var omp = 0;



dllfunction InventoryTriggered(var);
dllfunction InventoryTriggeredOver(var);
dllfunction InventoryTriggeredOff(var);







function TriggerManipulate()
{
if (omp == 0)
	{
	omp = 1;
	Manipulate();
	}
else
	{
	omp = 0;
	}
}


function TriggerManipulateOff()
{
omp = 0;
}

function Manipulate()
{
while(omp == 1)
	{
	ObjetManipulator(mouse_pos.x, mouse_pos.y, 1);
	wait(1);
	}

}




dllfunction MyMaterialModus(var);

function OMON()
{
if (ObjektManipulation.visible == ON)
	{
	MyMaterialModus(2);
	ObjektManipulation.visible = OFF;
	HideAktionsMenu();
	}
else
	{
	if (Gauge.visible == off)
		{
		Gauge.visible = on;
		}
	MyMaterialModus(1);
	ObjektManipulation.visible = ON;
	}
}



function gaugecheck
{
	if (Gauge.visible == ON) 
	{ 
	Gauge.visible = OFF;
	Texttafel.visible = OFF;
	/////////////////////////////////////
	ObjektManipulation.visible = OFF;
	HideAktionsMenu();
	MyMaterialModus(2);
	
	GaugeON.visible = ON;
	}
	else		 { Gauge.visible = ON;}
}




on_i = OMON;


//-----------------------------------------------------------------------------
//     generated by MobileRooms - http://www.superfluxus.de
//-----------------------------------------------------------------------------

panel SavePanel
{
pos_x 123;         
pos_y 553;
bmap mat;
layer = 5;
flags refresh, d3d; 
}



function ShowSavePanel()
{
SavePanel.visible = on;
}

function HideSavePanel()
{
SavePanel.visible = off;
}


function SwitchSavePanel()
{
if (SavePanel.visible == on)
	{
	SavePanel.visible = off;
	}	
else
	{
	SavePanel.visible = on;
	}
}



on_f12 = SwitchSavePanel;

//-----------------------------------------------------------------------------
//     generated by MobileRooms - http://www.superfluxus.de
//-----------------------------------------------------------------------------



// uses: duration, distancia, _attached, _attentive, _interactive, _physical, _combat, font_size, _screenX, _screenY, _red, _green, _blue, screenpos
action GameDisplay
{
my.typ = 222;                        // das ist das Display fr die Demo

// my.material = mat_smaragd;

///// Das ist die ID  /////
my.skill34 = 0;

ThingsAssign();
my.event = ThingEvent;
	while(1)
	{
	CallThings(my.erkennung);
	if (my.conditions == 777)
		{
		}

	wait(1);
	}
}





//-----------------------------------------------------------------------------
// Name: 
// Desc: 
//-----------------------------------------------------------------------------




dllfunction DiaryInsert(void_var);
dllfunction AppendToDiary(void_var);
dllfunction TriggerKey(var);


var DialogTextLength = 0;
//string DialogText = "DialogText                                                                                                                                  ";
string DialogText[1000];

var inputCounter = 0;

function AppendToMyDiary()
{
inputCounter = 0;
DiaryInsert();
DialogTextLength = str_len(DialogText);
str_trunc(DialogText, DialogTextLength);

inkey(DialogText);


if (result == 13 )
		{
		DialogTextLength = str_len(DialogText);
		AppendToDiary();
		}

}



on_a = AppendToMyDiary;




panel text_eingabe
{
  pos_X = 0; pos_y = 55;
  digits = 0, 0, 5, digit_font, 1,inputCounter; // zeige Anzahl der Partikel 
  flags = REFRESH;
}


//-----------------------------------------------------------------------------
// Name: Zahleneingabe
// Desc: 
//-----------------------------------------------------------------------------
var zahlCounter = 0;
var NumberInputLength;
string NumberInput = "                ";


function Zahleneingabe()
{
beep;
zahlCounter = 0;
NumberInputLength = str_len(NumberInput);
str_trunc(NumberInput, DialogTextLength);

inkey(NumberInput);


if (result == 13 )
		{
		}

}

on_f = Zahleneingabe;



///////////////////////////////////////////////

var s_angle[3]; 
var s_dir[3];

function bounce_event 
{
  if (EVENT_TYPE == EVENT_BLOCK) 
  {
  beep;
  vec_TO_ANGLE(my.pan,BOUNCE); // Abprall-Richtung
  }

  if (event_type == event_click)
  {
  my.skill10 = 1;
  }



} 

action bounceball 
{
  my.enable_click = on;
  my.ENABLE_BLOCK = ON; // mache Entity sensitiv fuer Block-Kollisionen
  my.ENABLE_ENTITY = ON; // mache Entity sensitiv fuer Entity-Kollisionen 
  my.EVENT = bounce_event;

	while(1)
		{
		if (my.skill10 == 1)
			{
			s_dir[0] = 0;
			s_dir[1] = 0;
			s_dir[2] = -1;

			ent_move(s_dir, nullvector);
			}
		wait(1);
		}

}




BMAP ButtonT,<ButtonT.bmp>; 
BMAP ButtonU,<ButtonU.bmp>; 
BMAP Tastatur,<Tastatur.bmp>; 
BMAP energia, <Energy.tga>;
BMAP energiaP, <EnergyP.tga>;
BMAP HandyOff, <HandyOff.tga>;
BMAP HandyOver, <HandyOver.tga>;


PANEL NumInput
{
    BMAP Tastatur;
    POS_X 550;
    POS_Y 110;
    BUTTON 121, 270, ButtonT, NULL, ButtonT, TypeIN, NULL, NULL;
    BUTTON 121, 228, ButtonT, NULL, ButtonT, TypeIN, NULL, NULL;
    BUTTON 168, 228, ButtonT, NULL, ButtonT, TypeIN, NULL, NULL;
    BUTTON 215, 228, ButtonT, NULL, ButtonT, TypeIN, NULL, NULL;
    BUTTON 121, 188, ButtonT, NULL, ButtonT, TypeIN, NULL, NULL;
    BUTTON 168, 188, ButtonT, NULL, ButtonT, TypeIN, NULL, NULL;
    BUTTON 215, 188, ButtonT, NULL, ButtonT, TypeIN, NULL, NULL;
    BUTTON 121, 148, ButtonT, NULL, ButtonT, TypeIN, NULL, NULL;
    BUTTON 168, 148, ButtonT, NULL, ButtonT, TypeIN, NULL, NULL;
    BUTTON 215, 148, ButtonT, NULL, ButtonT, TypeIN, NULL, NULL;
	
	BUTTON 168, 270, ButtonT, NULL, ButtonU, TypeIN, NULL, NULL;
	BUTTON 215, 270, ButtonT, NULL, ButtonU, TypeIN, NULL, NULL;

	window 20, 166, 12, 12, rlight, gwindow, 0;
	window 0, 317, 273, 2, tape, hwindow, 0;

    LAYER 3;
    FLAGS OVERLAY, REFRESH;
}



function NumInputCheck()
{
if (NumInput.visible == ON)
	{
	NumInput.visible = OFF;
	}
else 
	{
	NumInput.visible = ON;
	}
}


function HideNumInput()
{
NumInput.visible = OFF;
}


dllfunction TypeNo(var);
dllfunction ClearSafe();
dllfunction Nummerneingabe(var);

function TypeIN(buttonNr)
{
if (buttonNr == 1)        // eine 0
	{
	TypeNo(0);
	}

if (buttonNr == 2)        // eine 1
	{
	TypeNo(1);
	}

if (buttonNr == 3)        // eine 2
	{
	TypeNo(2);
	}

if (buttonNr == 4)        // eine 3
	{
	TypeNo(3);
	}

if (buttonNr == 5)        // eine 3
	{
	TypeNo(4);
	}


if (buttonNr == 6)        // eine 3
	{
	TypeNo(5);
	}

if (buttonNr == 7)        // eine 3
	{
	TypeNo(6);
	}

if (buttonNr == 8)        // eine 3
	{
	TypeNo(7);
	}

if (buttonNr == 9)        // eine 3
	{
	TypeNo(8);
	}

if (buttonNr == 10)        // eine 3
	{
	TypeNo(9);
	}

if (buttonNr == 11)
	{
	ClearSafe();
	}

if(buttonNr == 12)
	{
	Nummerneingabe(0);
	}
}


//-----------------------------------------------------------------------------
// Name: Zahleneingabe
// Desc: 
//-----------------------------------------------------------------------------
dllfunction PhoneOff(void_var);
dllfunction TypePhoneNo(var);
string PhoneNumberInput = "03079707338";

dllfunction CallPhoneNumber(void_var);
dllfunction StopCalling();
dllfunction SwitchPhone(void_var);



var PhoneEnergy = 0;
var pWin = 12;

PANEL PhoneInput
{
	on_click PhonePanelOff;


    BMAP Tastatur;
    POS_X 550;
    POS_Y 110;
    BUTTON 121, 270, ButtonT, NULL, ButtonT, TypePhone, NULL, NULL;
    BUTTON 121, 228, ButtonT, NULL, ButtonT, TypePhone, NULL, NULL;
    BUTTON 168, 228, ButtonT, NULL, ButtonT, TypePhone, NULL, NULL;
    BUTTON 215, 228, ButtonT, NULL, ButtonT, TypePhone, NULL, NULL;
    BUTTON 121, 188, ButtonT, NULL, ButtonT, TypePhone, NULL, NULL;
    BUTTON 168, 188, ButtonT, NULL, ButtonT, TypePhone, NULL, NULL;
    BUTTON 215, 188, ButtonT, NULL, ButtonT, TypePhone, NULL, NULL;
    BUTTON 121, 148, ButtonT, NULL, ButtonT, TypePhone, NULL, NULL;
    BUTTON 168, 148, ButtonT, NULL, ButtonT, TypePhone, NULL, NULL;
    BUTTON 215, 148, ButtonT, NULL, ButtonT, TypePhone, NULL, NULL;
	
	BUTTON 168, 270, ButtonT, NULL, ButtonU, TypePhone, NULL, NULL;
	BUTTON 215, 270, ButtonT, NULL, ButtonU, TypePhone, NULL, NULL;

	window 20, 166, 12, 12, rlight, pWin, 0;
	window 0, 317, 273, 2, tape, hwindow, 0;

	BUTTON 200, 20, energiaP, energiaP, energiaP, NULL, NULL, NULL;
	window 200, 20, 35, 7, energia, PhoneEnergy, 0;

	BUTTON 12, 190, HandyOff, HandyOff, HandyOver, SwitchPhone, NULL, NULL;


    LAYER 3;
    FLAGS OVERLAY, REFRESH;
}


function PhonePanelOff()
{
PhoneOff(0);
PhoneInput.visible = off;
}


function PhoneInputCheck()
{
if (PhoneInput.visible == off)
	{
	PhoneInput.visible = on;
	}
else
	{
	PhoneInput.visible = off;
	}
}




function TypePhone(buttonNr)
{
if (buttonNr == 1)        // eine 0
	{
	TypePhoneNo(0);
	}

if (buttonNr == 2)        // eine 1
	{
	TypePhoneNo(1);
	}

if (buttonNr == 3)        // eine 2
	{
	TypePhoneNo(2);
	}

if (buttonNr == 4)        // eine 3
	{
	TypePhoneNo(3);
	}

if (buttonNr == 5)        // eine 3
	{
	TypePhoneNo(4);
	}


if (buttonNr == 6)        // eine 3
	{
	TypePhoneNo(5);
	}

if (buttonNr == 7)        // eine 3
	{
	TypePhoneNo(6);
	}

if (buttonNr == 8)        // eine 3
	{
	TypePhoneNo(7);
	}

if (buttonNr == 9)        // eine 3
	{
	TypePhoneNo(8);
	}

if (buttonNr == 10)        // eine 3
	{
	TypePhoneNo(9);
	}

if (buttonNr == 11)
	{
	StopCalling();
	}

if(buttonNr == 12)
	{
	CallPhoneNumber(0);
	}
}



//-----------------------------------------------------------------------------
// Name: FoolsGame
// Desc: 
//-----------------------------------------------------------------------------
dllfunction StartFoolsGame(void_var);

BMAP TrottelSpiel,<Fools.bmp>; 
BMAP GO_ON,		<go_on.tga>;
BMAP GO_OVER,	<go_over.tga>;
BMAP GO_OFF,	<go_off.tga>;

panel FoolsGame
{
on_click FoolsGameOff;


BMAP TrottelSpiel;
POS_X 550;
POS_Y 110;

BUTTON 118, 185, GO_ON, GO_OFF, GO_OVER, StartFoolsGame, NULL, NULL;


FLAGS OVERLAY, REFRESH;
}




function FoolsGameOff()
{
FoolsGame.visible = off;
}


function FoolsGameOn()
{
FoolsGame.visible = on;
}






dllfunction TriggerGameEnd(void_var);

on_e = TriggerGameEnd;




string YesOrNo;

function StartNewGame()
{
inkey(YesOrNo);
if (result == 13 )
		{
		beep;
		}
}




function Nebel()
{
camera.ambient += 5;
bg_color.red = 200;
}

on_n = Nebel;





////////////////////////////////////////////////////////////
// bmap bmp_envcube = <Desert+6.bmp>;
//////////////////////////////////////////////////////////////////////////////////
panel actionanzeige
{
  pos_X = 600; pos_y = 100;

  digits = 0, 0, 4, digit_font, 1,num_entities; // zeige Anzahl der Level-Entities
  digits = 0, 20, 4, digit_font, 1,num_actions; // zeige Anzahl der laufenden Aktionen
  digits = 0, 40, 4, digit_font, 1,D3D_TEXfree; // zeige Anzahl der laufenden Aktionen
  // digits = 0, 60, 4, digit_font, 1,fps; // zeige Anzahl der laufenden Aktionen


  flags = REFRESH;
}










dllfunction _onspace(void_var);
dllfunction _onrightclick(void_var);
dllfunction _oncontrol(void_var);

on_space		= _onspace;
on_click        = _onrightclick;
on_ctrl         = _oncontrol;




////////////////////////////////////////////////////////////////
dllfunction LevelTest(void_var);


string level_name = <LevelChange.wmb>;

function ChangeMyLevel()
{
load_level(level_name); // laden Level level.wmb
wait(1);
}

// on_j = LevelTest;



dllfunction LevelCreation(void_var);


// on_k = LevelCreation;





function SaveScaledBitmap()
{
beep;
// bmap_for_screen(dsk, 8, 0);
// wait(3);
game_save("test",0, SV_BMAPS);
}



// on_j = PlayIntro();

// on_j = SaveScaledBitmap;





function SwitchOffStartPanels()
{
// beep;
gaugecheck();
ZeitungsTafel.visible = off;
TextTafel.visible     = off;
}


on_j = SwitchOffStartPanels;



function DoNothing()
{
beep;
}

on_esc = DoNothing();




